package com.emoon.knowledge.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.knowledge.domain.ThinkMcp;
import com.emoon.knowledge.domain.bo.ThinkMcpBo;
import com.emoon.knowledge.domain.vo.ThinkMcpVo;
import com.emoon.knowledge.mapper.ThinkMcpMapper;
import com.emoon.knowledge.service.IThinkMcpService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author wangkang
 * @date 2025-11-26
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ThinkMcpServiceImpl implements IThinkMcpService {

    private final ThinkMcpMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 主键
     * @return 【请填写功能名称】
     */
    @Override
    public ThinkMcpVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询【请填写功能名称】列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 【请填写功能名称】分页列表
     */
    @Override
    public TableDataInfo<ThinkMcpVo> queryPageList(ThinkMcpBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ThinkMcp> lqw = buildQueryWrapper(bo);
        Page<ThinkMcpVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的【请填写功能名称】列表
     *
     * @param bo 查询条件
     * @return 【请填写功能名称】列表
     */
    @Override
    public List<ThinkMcpVo> queryList(ThinkMcpBo bo) {
        LambdaQueryWrapper<ThinkMcp> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ThinkMcp> buildQueryWrapper(ThinkMcpBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ThinkMcp> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ThinkMcp::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getMcp()), ThinkMcp::getMcp, bo.getMcp());
        lqw.eq(StringUtils.isNotBlank(bo.getMcpintroduce()), ThinkMcp::getMcpintroduce, bo.getMcpintroduce());
        lqw.eq(StringUtils.isNotBlank(bo.getMcpOutdata()), ThinkMcp::getMcpOutdata, bo.getMcpOutdata());
        lqw.eq(StringUtils.isNotBlank(bo.getMcpIndata()), ThinkMcp::getMcpIndata, bo.getMcpIndata());
        lqw.eq(StringUtils.isNotBlank(bo.getMcpUrl()), ThinkMcp::getMcpUrl, bo.getMcpUrl());
        lqw.eq(bo.getSort() != null, ThinkMcp::getSort, bo.getSort());
        lqw.eq(StringUtils.isNotBlank(bo.getAgent()), ThinkMcp::getAgent, bo.getAgent());
        lqw.eq(bo.getState() != null, ThinkMcp::getState, bo.getState());
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ThinkMcpBo bo) {
        ThinkMcp add = MapstructUtils.convert(bo, ThinkMcp.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ThinkMcpBo bo) {
        ThinkMcp update = MapstructUtils.convert(bo, ThinkMcp.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ThinkMcp entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除【请填写功能名称】信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
